#include <iostream>
#include <string.h>
#include <errno.h>
#include <stdlib.h> 	// system
#include <wiringPi.h>
#include <wiringSerial.h>
#include "compteurEDF.h"

using namespace std;

// g++ -o compteur_EDF_3 -lwiringPi compteur_EDF_3.cpp compteurEDF.cpp

int main ()
{
compteurEDF compt1 ;

  if (wiringPiSetup () == -1)
  {
   cout<<"Impossible de démarrer wiringPi. Erreur : "<<strerror (errno);
   return 1 ;
  }

compt1.set_fd(serialOpen ("/dev/ttyAMA0", 1200));
  if (compt1.get_fd ()< 0)
  {
 	cout<<"Impossible d'ouvrir le port /dev/ttyAMA0. Erreur : "<<strerror (errno);
	return 1 ;
  }

int Nb_captures=0;
char data[400];

while(1)
	{
	do
		{
		do
			{
			compt1.set_data(0,127&serialGetchar(compt1.get_fd ()));  // Capture et stockage du 1er caractère ...
			}
		while (compt1.get_data(0)!='A');	// ... jusqu'à capture d'un 'A'
		compt1.set_data(1,127&serialGetchar(compt1.get_fd ()));  // Capture et stockage du 2ème caractère
		}
	while ((compt1.get_data(0)!='A')||(compt1.get_data(1)!='D'));	// ... jusqu'à capture d'un 'A' suivi d'un 'D'	

	for (int i(2); i<170; i++)
		{
		compt1.set_data(i,127&serialGetchar(compt1.get_fd ()));  // Capture de tous les autres caractères de la trame
		}
	Nb_captures++;
	system("clear");
	cout<<"Capture N° : "<<Nb_captures<<endl;
	compt1.affiche_ADCO();
	}

serialFlush(compt1.get_fd ());		// Effacement buffers série avant lecture Rx
serialClose(compt1.get_fd ());		// Fermeture du port série

return 0;
}